<?php
/**************************************************************************
 * $Id: StudIPortExtAccPortalPlugin.class.php 4532 2011-01-13 13:25:38Z renner $
 *
 * Copyright (C) 2008, 2009, 2010; Hamburg University of Technology
 *
 * > TECHNICAL REALIZATION
 *   Christian Renner <christian.renner@tu-harburg.de>
 *   Leo Krueger
 *   Sigurd Spieckermann
 *
 * > CONCEPT
 *   Peter Baasch
 *   Detlev Bieler
 *   Thomas Czerwionka
 *   Thomas Hapke
 *   Soenke Knutzen
 *   Corinna Peters
 *   Christian Renner
 *   Volker Turau
 *   Olav Wilde
 *
 **************************************************************************
 * This file is part of "StudIPort 2.0 ePortfolio".
 *
 * "StudIPort 2.0 ePortfolio" is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * "StudIPort 2.0 ePortfolio" is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "StudIPort 2.0 ePortfolio".
 * If not, see <http://www.gnu.org/licenses/>.
 *
 *************************************************************************/


/* always load config */
require_once('config/StudIPort.config.php');
require_once('StudIPortDB.system.php');
require_once('StudIPortUser.system.php');
require_once('StudIPortAvatar.system.php');

require_once('StudIPortExtAccess.lib.php');

require_once('ext/flexi-templates/flexi.php');


class StudIPortExtAccPortalPlugin extends AbstractStudIPPortalPlugin {

	public function __construct() {
		parent::AbstractStudIPPortalPlugin();
	}



	/*
	 * inserts additionally required CSS and JavaScript
	 * @param void
	 */
	public function initialize() {
		global $HELP_KEYWORD, $EXTERNAL_HELP_LOCATIONID;
		$HELP_KEYWORD="Basis.ePortfolio";
		$EXTERNAL_HELP_LOCATIONID = tuhh;

		// FIXME localization and foreign language support ....
		setlocale(LC_ALL, 'de_DE');
		new StudIPortDB("SET lc_time_names = 'de_DE'");

		// set additional headers
		global $_include_additional_header;

                // include css
                global $studiport_css_header;
                $_include_additional_header .= $studiport_css_header;

                // include js
                global $studiport_js_header;
                $_include_additional_header .= $studiport_js_header;
	}

	public function showOverview($studiportAuthorizedview = false) {
		$factory = new Flexi_TemplateFactory(STUDIPORT_TEMPLATES);
		$template = $factory->open("ExtAccLogin.php");

		$url = $this->getPluginURL();
		$template->set_attribute("url", $url);
		$template->set_attribute("formaction", PluginEngine::getLink($this, NULL, "view"));

		echo $template->render();
  	}

	public function getPluginname() {
		return _("Externer Zugriff auf ePortfolios");
	}

	public function hasUnauthorizedView() {
		return false;
	}

	public function hasAuthorizedView() {
		return false;
	}

	public function hasAdministration() {
		return false;
	}

	public function actionview($pluginparams) {
		if (empty($_REQUEST["access_code"]) || empty($_REQUEST["view_id"])) {
			StudIPTemplateEngine::showErrorMessage("Geben Sie die geforderten Zugangsdaten an.");
			$this->showOverview();
			return;
		}

		// check if code & id match
		$res = array();
		if (! validateViewExtAccess($_REQUEST["view_id"], $_REQUEST["access_code"], $res)) {
			StudIPTemplateEngine::showErrorMessage("Ung&uuml;ltige Zugangsdaten");
			$this->showOverview();
			return;
		}

		// set the session variable for the external plugin and assign access code
		$_SESSION['StudIPortExtAcc']['access_code'] = $_REQUEST["access_code"];

		$factory = new Flexi_TemplateFactory(dirname(__FILE__) ."/templates");
		$template = $factory->open("empty.php");
		$template->set_layout("StudIPortStudIP.php");
		$template->set_attribute("url",  $this->getPluginURL());

		require_once("StudIPortPageViewExtAcc.class.php");
		$view_id = intval($_REQUEST['view_id']);
		$files = new StudIPortPageViewExtAcc(new StudIPortUser(StudIPortUser::NOBODY), $view_id);
		$files->loadData();

		$template->set_attribute('StudIPortContent', $files->render($factory, "StudIPortViewAlien.page.php", $this->getPluginURL()));
		echo $template->render();
	}
}
?>
