<?php
/**************************************************************************
 * $Id: StudIPortPrintView.php 4351 2010-09-07 08:52:11Z renner $
 *
 * Copyright (C) 2008, 2009, 2010; Hamburg University of Technology
 *
 * > TECHNICAL REALIZATION
 *   Christian Renner <christian.renner@tu-harburg.de>
 *   Leo Krueger
 *   Sigurd Spieckermann
 *
 * > CONCEPT
 *   Peter Baasch
 *   Detlev Bieler
 *   Thomas Czerwionka
 *   Thomas Hapke
 *   Soenke Knutzen
 *   Corinna Peters
 *   Christian Renner
 *   Volker Turau
 *   Olav Wilde
 *
 **************************************************************************
 * This file is part of "StudIPort 2.0 ePortfolio".
 *
 * "StudIPort 2.0 ePortfolio" is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * "StudIPort 2.0 ePortfolio" is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "StudIPort 2.0 ePortfolio".
 * If not, see <http://www.gnu.org/licenses/>.
 *
 *************************************************************************/


require_once dirname(__file__)."/../../../../lib/bootstrap.php";

require_once('config/StudIPort.config.php');

require_once('StudIPortAuth.system.php');
require_once('StudIPortDB.system.php');
require_once('StudIPortUser.system.php');

require_once('StudIPortAccess.lib.php');
require_once('StudIPortExtAccess.lib.php');

require_once('print/StudIPortPDFView.class.php');

$studiportAuth = new StudIPortAuth();

// auth check
// 1.) try whether view belongs to user or direct access is granted inside the system
// 2.) if this fails, try if an access code has been provided
$res = array();
if (! validateViewAccess($_REQUEST['view_id'], StudIPortUser::theUser()->getUserId(), $res, VIEW_ROLE_ALIEN)) {
	if (! validateViewExtAccess($_REQUEST['view_id'], $_SESSION['StudIPortExtAcc']['access_code'], $res)) {
		die($res['errorMsg']);
	}
}

// create new PDF view
$pdf = new StudIPortPDFView($_REQUEST['view_id']);
if (! $pdf->create()) {
	die($pdf->get_error());
}

// everything is fine => set file header, name, ending and mime-type and load file content into this script
header("HTTP/1.1 200 OK");
header("Content-Type: application/pdf");
header("Content-Disposition: attachment; filename=\"view.pdf\"");

echo $pdf->getPDF();

