<?php
/**************************************************************************
 * $Id: StudIPortURLUpload.php 4574 2011-01-18 08:24:51Z renner $
 *
 * Copyright (C) 2008, 2009, 2010; Hamburg University of Technology
 *
 * > TECHNICAL REALIZATION
 *   Christian Renner <christian.renner@tu-harburg.de>
 *   Leo Krueger
 *   Sigurd Spieckermann
 *
 * > CONCEPT
 *   Peter Baasch
 *   Detlev Bieler
 *   Thomas Czerwionka
 *   Thomas Hapke
 *   Soenke Knutzen
 *   Corinna Peters
 *   Christian Renner
 *   Volker Turau
 *   Olav Wilde
 *
 **************************************************************************
 * This file is part of "StudIPort 2.0 ePortfolio".
 *
 * "StudIPort 2.0 ePortfolio" is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * "StudIPort 2.0 ePortfolio" is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "StudIPort 2.0 ePortfolio".
 * If not, see <http://www.gnu.org/licenses/>.
 *
 *************************************************************************/

require_once dirname(__file__)."/../../../../lib/bootstrap.php";

require_once('config/StudIPort.config.php');

require_once('StudIPortAuth.system.php');
require_once('StudIPortUser.system.php');
require_once('StudIPortDB.system.php');

require_once('StudIPortUploadTools.lib.php');
require_once('StudIPortFileTools.lib.php');
require_once('StudIPortTools.lib.php');

$studiportAuth = new StudIPortAuth();
$studiportAuth->isLoggedIn(true);


if (!isset($_POST)) exit;

$url = $_POST['URLUpload_File'];

if (!isset($url)) {
	uploadError('Es wurde keine URL übertragen!');
}

if (strlen($url) > 255) {
	uploadError('Die URL darf nicht länger als 255 Zeichen sein!');
}

$validURL = isValidURL($url);

if ($validURL === 1) {
	uploadError('Die Adresse hat ein ungueltiges Format!');
} elseif ($validURL === 2) {
	uploadError('Die Adresse verweist auf eine ungueltige Website!');
}

// get db connection
$db = new StudIPortDB();

// user id
$userid = StudIPortUser::theUser()->getUserId();


// FIXME use same function as in StudIPortFileUpload.php
$baseTitle = $title = parse_url($url, PHP_URL_HOST) . parse_url($url, PHP_URL_PATH);
if (empty($title)) {
	$baseTitle = $title = $url;
}
for ($n = 2; $n <= STUDIPORT_FILES_MAXDUP; $n++) {
	// IMPROVE and CHECK title vs filename
	$db->queryf("SELECT file_id FROM studiport_file WHERE title='%s' AND user_id='%s'", $title, $userid);
	if ($db->num_rows() == 0) {
		break;
	}
	$title = $baseTitle . " (" . $n . ")";
}

// insert everthing into DB
$db->queryf("INSERT INTO studiport_file SET "
	  . "int_filename  = NULL, "
	  . "filename      = '%s', "
	  . "type_id       = '%d', "
	  . "mimetype      = '', "
	  . "filesize      = '%d', "
	  . "created       = NOW(), "
	  . "edited        = NOW(), "
	  . "title         = '%s', "
	  . "descr_int     = '', "
	  . "descr_ext     = '', "
	  . "user_id       = '%s'",
	  $url, STUDIPORT_FILETYPE_URL, strlen($url), $title, $userid);

// check, if data could be inserted in mysql
if ($db->affected_rows() == 0) {
	uploadError('URL konnte nicht in Datenbank eingef&uuml;gt werden');
}

// get new list of unassociated files
// FIXME obsolete here
$fileObj = filesGetNoAssocList();
$fileList = array(
	'num' => $fileObj['number'],
	'htmlContent' => StudIPortDB::convertFromDB($fileObj['htmlContent'])
);
$fileListJSON = json_encode($fileList);

// FIXME obsolete here
// get new quota statistics
$quota = uploadGetUsageStat($userid);
foreach ($quota as $k=>$v) {
	$quota[$k] = StudIPortDB::convertFromDB($v);
}
$quotaJSON = json_encode($quota);

// set success message and create a new upload key
$msg  = "Die Datei '". $title ."' wurde erfolgreich hochgeladen und kann nun zugeordnet werden.";
// FIXME obsolete here
$pkey = createUploadKey();

// show success or error message
// NOTE reloading Prototype is required by Konqueror (and possibly Safari) to
// make things like update() work
echo "<html><head>\n";
echo "<script type='text/javascript' src='". STUDIPORT_JS_URI ."/prototype/prototype.js'></script>\n";
echo "<script type='text/javascript'>\n";
echo "var pkey    = '". $pkey ."'\n";
echo "var msg     = '". addslashes($msg) ."'\n";
echo "var fileLst = ". $fileListJSON ."\n";
echo "var quota   = ". $quotaJSON ."\n";
echo "top.urlUpload.success(pkey, msg, quota, fileLst);\n";
echo "</script>\n";
echo "</head><body></body></html>\n";

// end of script, functions below
function uploadError($msg) {
	$pkey = createUploadKey();
	// NOTE reloading Prototype is required by Konqueror (and possibly Safari) to
	// make things like update() work
	echo "<html><head>\n";
	echo "<script type='text/javascript' src='". STUDIPORT_JS_URI ."/prototype/prototype.js'></script>\n";
	echo "<script type='text/javascript'>\ntop.urlUpload.error('$pkey', '". addslashes(htmlentities($msg)) ."');\n</script>\n";
	echo "</head><body></body></html>\n";
	exit;
}

?>
