<?php
/**************************************************************************
 * $Id: user.php 4579 2011-01-18 11:18:33Z renner $
 *
 * Copyright (C) 2008, 2009, 2010; Hamburg University of Technology
 *
 * > TECHNICAL REALIZATION
 *   Christian Renner <christian.renner@tu-harburg.de>
 *   Leo Krueger
 *   Sigurd Spieckermann
 *
 * > CONCEPT
 *   Peter Baasch
 *   Detlev Bieler
 *   Thomas Czerwionka
 *   Thomas Hapke
 *   Soenke Knutzen
 *   Corinna Peters
 *   Christian Renner
 *   Volker Turau
 *   Olav Wilde
 *
 **************************************************************************
 * This file is part of "StudIPort 2.0 ePortfolio".
 *
 * "StudIPort 2.0 ePortfolio" is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * "StudIPort 2.0 ePortfolio" is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "StudIPort 2.0 ePortfolio".
 * If not, see <http://www.gnu.org/licenses/>.
 *
 *************************************************************************/

require_once("StudIPortUserTools.lib.php");
require_once('StudIPortDB.system.php');

/**
 * general functions
 */

function userSearch() {
	$res = array(
		'success' => 'false',
		'htmlContent' => '');

	// check input
	$query = trim($_REQUEST['qStr']);
	if (strlen($query) < 3) {
		setErrorMsg($res, "Suchmaske zu kurz");
		return $res;
	}

	// clean up user input
	$query = sanitizeInput($query);

	// find users and make a nice little list of them
	$userLst = array();
	StudIPortUser::searchByName($userLst, $query, STUDIPORT_USER_SEARCH_LIMIT);

	// issue a warning, if there might be more results available
	if (count($userLst) >= STUDIPORT_USER_SEARCH_LIMIT) {
		addWarning($res, "Zeige die ersten ". STUDIPORT_USER_SEARCH_LIMIT ." Ergebnisse, möglicherweise sind weitere vorhanden.");
	}
	
	// now create the list
	$htmlContent = "";
	foreach ($userLst as $user) {
		$htmlContent .= getUserListEntry($user, "x:");
	}

	// prepare result
	$res['success']     = true;
	$res['htmlContent'] = StudIPortDB::convertFromDB($htmlContent);

	return $res;
}
?>
