<?php

/* Override config with local settings */
if (file_exists(dirname(__FILE__) . '/StudIPort.config.local.php')) {
	require_once('StudIPort.config.local.php');
}


// SYSTEM LAYER CONFIG
//defDefault('STUDIPORT_SYSTEM_LAYER',     'standalone');
defDefault('STUDIPORT_SYSTEM_LAYER',     'studip');


if (STUDIPORT_SYSTEM_LAYER == 'studip') {

	// plugin name
	defDefault('STUDIPORT_PLUGIN_NAME',      "StudIPort");
	defDefault('STUDIPORT_PLUGIN_CLASS',     "StudIPortSystemPlugin");

	// plugin extension path
	defDefault('STUDIPORT_RELATIVE_PATH',    "/TUHH/StudIPortSystemPlugin");

	// due to some changes in Stud.IP 2.1, we need to tweak the globals a little
	// NOTE this is best effort only and might not be compatible with
	// future Stud.IP versions
	// NOTE appears that we only need bootstrap.php, if it isn't already there
	// => check that
/**
	// --- start of Stud.IP 2.1 fix
	if (! isset($GLOBALS['PLUGINS_PATH'])) {
		$p = dirname(__FILE__);
		$GLOBALS['PLUGINS_PATH'] = substr($p, 0, strlen('/plugins_packages') + strpos($p, '/plugins_packages'));
	}
	if (! isset($GLOBALS['ABSOLUTE_URI_STUDIP'])) {
		// URI of calling script
		$GLOBALS['ABSOLUTE_URI_STUDIP'] = 'http://'. $_SERVER['SERVER_NAME'] . dirname($_SERVER['REQUEST_URI']);
	}
	if (! isset($GLOBALS['STUDIP_BASE_PATH'])) {
		$p = dirname(__FILE__);
		$GLOBALS['STUDIP_BASE_PATH'] = substr($p, 0, strpos($p, '/public'));
		// if this variable isn't set, we also have to manipulate the PHP path
		set_include_path(
			get_include_path()                       .PATH_SEPARATOR.
			$GLOBALS['STUDIP_BASE_PATH']             .PATH_SEPARATOR.
			$GLOBALS['STUDIP_BASE_PATH'] .'/config'
		);
		// TODO this does not suffice, since AJAX wants to run page_open, which it
		// cannot find in 2.1 ...
	}
**/
	// --- end of Stud.IP 2.1 fix

	// setup base dir and URI
	defDefault('STUDIPORT_BASEDIR',          $GLOBALS['PLUGINS_PATH'] . STUDIPORT_RELATIVE_PATH);
	if (strpos($GLOBALS['ABSOLUTE_URI_STUDIP'], STUDIPORT_RELATIVE_PATH) === false) {
		defDefault('STUDIPORT_URI',      $GLOBALS['ABSOLUTE_URI_STUDIP'] . "plugins_packages" . STUDIPORT_RELATIVE_PATH);
	} else {
		defDefault('STUDIPORT_URI',      $GLOBALS['ABSOLUTE_URI_STUDIP']);
	}

	defDefault('STUDIPORT_EXT_ACCESS_URI',   $GLOBALS['ABSOLUTE_URI_STUDIP'] ."plugins.php/studiportextaccportalplugin/view?cid=");
	defDefault('STUDIPORT_DOWNLOAD_DIR',     $GLOBALS['STUDIP_BASE_PATH'] ."/data/upload_StudIPort");

	defDefault('STUDIPORT_LOG_PATH',         $GLOBALS['STUDIP_BASE_PATH'] ."/data/log/");

} else {

	// setup base dir and URI
	//defDefault('STUDIPORT_BASEDIR',          '/srv/www/studiport');
	defDefault('STUDIPORT_BASEDIR',          dirname(__FILE__) .'/../');
	defDefault('STUDIPORT_URI',              '/studiport');
	defDefault('STUDIPORT_EXT_ACCESS_URI',   'http://'. $_SERVER['SERVER_NAME'] . STUDIPORT_URI .'/external.php?');
	defDefault('STUDIPORT_DOWNLOAD_DIR',     STUDIPORT_BASEDIR . '/data/upload');
	defDefault('STUDIPORT_LOG_PATH',         STUDIPORT_BASEDIR . '/data/log/');

	defDefault('STUDIPORT_SESSION_TIMEOUT',  9000);

        // setup database connection
        defDefault('STUDIPORT_DB_HOST',     'localhost');
        defDefault('STUDIPORT_DB_USER',     'studiport');
        defDefault('STUDIPORT_DB_PASSWORD', 'studiport');
        defDefault('STUDIPORT_DB_DATABASE', 'studiport');

        // setup ldap connection
        defDefault('STUDIPORT_LDAP_HOST',   '172.28.77.139');
        defDefault('STUDIPORT_LDAP_PORT',   '3268');
        defDefault('STUDIPORT_LDAP_USERPOSTFIX', '');
        defDefault('STUDIPORT_LDAP_BASEDN', 'dc=tu-harburg,dc=de');

	defDefault('STUDIPORT_LDAP_VERSION', '3');

	defDefault('STUDIPORT_LDAP_DEBUGLEVEL', '0');

	ldap_set_option(NULL, LDAP_OPT_DEBUG_LEVEL, STUDIPORT_LDAP_DEBUGLEVEL);

	defDefault('STUDIPORT_LDAP_ATTR_LOGIN',       'sAMAccountName');
	defDefault('STUDIPORT_LDAP_UID_BINARY',       true);
	defDefault('STUDIPORT_LDAP_ATTR_UID',         'objectGUID');
	defDefault('STUDIPORT_LDAP_ATTR_FIRSTNAME',   'sn');
	defDefault('STUDIPORT_LDAP_ATTR_GIVENNAME',   'givenName');
}

// derived dirs
defDefault('STUDIPORT_AJAX_BASEDIR',     STUDIPORT_BASEDIR ."/ajax");

// derived paths
defDefault('STUDIPORT_AJAX_FOLDER',      'ajax');
defDefault('STUDIPORT_IMG_FOLDER',       'media/images');
defDefault('STUDIPORT_CSS_FOLDER',       'media/styles');
defDefault('STUDIPORT_JS_FOLDER',        'media/js');

// derived paths
defDefault('STUDIPORT_AJAX_URI',         STUDIPORT_URI ."/". STUDIPORT_AJAX_FOLDER);
defDefault('STUDIPORT_IMG_URI',          STUDIPORT_URI ."/". STUDIPORT_IMG_FOLDER);
defDefault('STUDIPORT_CSS_URI',          STUDIPORT_URI ."/". STUDIPORT_CSS_FOLDER);
defDefault('STUDIPORT_JS_URI',           STUDIPORT_URI ."/". STUDIPORT_JS_FOLDER);

// download/upload stuff
defDefault('STUDIPORT_FILES_MAXDUP',     10);  // max number of duplicates per file handled
defDefault('STUDIPORT_FILES_MAXSIZE',     50 * 1000 * 1000);  // maximum file size [byte]
defDefault('STUDIPORT_FILES_QUOTA',      250 * 1000 * 1000);  // maximum space allowed per user [byte]
defDefault('STUDIPORT_FILES_DEFAULTTYPE',1);  // default file type (from DB: studiport_file_types)

defDefault('STUDIPORT_FILETYPE_URL',     6);  // from DB: studiport_file_types
defDefault('STUDIPORT_FILETYPE_TEXT',    2);  // from DB: studiport_file_types

defDefault('STUDIPORT_FILES_DFLT_TEXT_EXT', ".txt");

// NOTE
// file sizes should be compared with the PHP.ini Config Values, at least when
// displaying and setting the maximum file size in the upload dialog
// Furthermore, remaining diskspace should be taken into consideration!

// special Ids for files without assoc (cols/rows (=exp/comp))
defDefault('STUDIPORT_COMP_NONE',        0);
defDefault('STUDIPORT_EXP_NONE',         0);

// versioning
defDefault('STUDIPORT_RELEASE',          "11.1 Final");
defDefault('STUDIPORT_RELEASENAME',      "Eifriges Eichh&ouml;rnchen (sciurus studiosus)");
$__confStat = stat(__FILE__);
defDefault('STUDIPORT_VERSION',          "1.0.0-". date('Ymd.Hi', $__confStat['mtime']));
unset($__confStat);

// styles for templates
defDefault('STUDIPORT_STYLE_STANDALONE', 'STYLE_STANDALONE');
defDefault('STUDIPORT_STYLE_NESTED',     'STYLE_NESTED');

// rights for views and stuff
defDefault('STUDIPORT_RIGHTS_OWNER',     'OWNER');
defDefault('STUDIPORT_RIGHTS_ALIEN',     'ALIEN');

// length of abbreviated strings
defDefault('STUDIPORT_FILE_DESCR_ABBR_LENGTH',         300);
defDefault('STUDIPORT_MATRIX_FILE_DESCR_ABBR_LENGTH',  150);
defDefault('STUDIPORT_QUESTION_MAX_DISP_LENGTH',        80);
defDefault('STUDIPORT_QUESTION_ABBR_LENGTH',           100);
defDefault('STUDIPORT_RESPONSE_ABBR_LENGTH',           100);

// number of days respones and others things are considered new
defDefault('STUDIPORT_DAYS_NEW',                        14);

// max results for user search
defDefault('STUDIPORT_USER_SEARCH_LIMIT',     50);

// relative paths for libs and system layer (PHP search path)
defDefault('STUDIPORT_SYSLIB_IFACES',    STUDIPORT_BASEDIR ."/lib/system");
defDefault('STUDIPORT_SYSLIB',           STUDIPORT_BASEDIR ."/lib/system/". STUDIPORT_SYSTEM_LAYER);
defDefault('STUDIPORT_LIB',              STUDIPORT_BASEDIR ."/lib");
defDefault('STUDIPORT_CLASSES',          STUDIPORT_BASEDIR ."/lib/classes");

defDefault('STUDIPORT_TEMPLATES',        STUDIPORT_BASEDIR ."/templates");

// update include path
set_include_path(
	get_include_path()          .PATH_SEPARATOR.
	STUDIPORT_LIB               .PATH_SEPARATOR.
	STUDIPORT_CLASSES           .PATH_SEPARATOR.
	STUDIPORT_SYSLIB_IFACES     .PATH_SEPARATOR.
	STUDIPORT_SYSLIB
);

// printing setup
defDefault('STUDIPORT_ENABLE_PRINTVIEW', false);    // true => on, false => off
defDefault('STUDIPORT_TEXINPUTS', STUDIPORT_BASEDIR ."/print/texmf//");

// style files and javascript
defDefault('STUDIPORT_CSS_FILES', 'StudIPort.css:Calendar.css:fakeUploadButton.css');
defDefault('STUDIPORT_JS_FILES', 'calendar/CalendarPopup.js:prototype/prototype.js:scriptaculous/scriptaculous.js:StudIPortDefault.js:matrix.js:cache.js:msgBox.js:upload.js:file.js:ajax.js:view.js:question.js:response.js:fakeUploadButton.js:box.js');

global $studiport_css_header;
$studiport_css_header = "";
foreach (explode(':', STUDIPORT_CSS_FILES) as $file) {
	$studiport_css_header .= "<link rel='stylesheet' href='". STUDIPORT_CSS_URI ."/". $file . "' type='text/css' />\n";
}


global $studiport_js_header;
$studiport_js_header  =
	"<script type='text/javascript'>var StudIPortImgUri = '" . STUDIPORT_IMG_URI ."/';</script>\n" .
	"<script type='text/javascript'>var StudIPortUrl = '". STUDIPORT_URI ."/';</script>\n";
foreach (explode(':', STUDIPORT_JS_FILES) as $file) {
  $studiport_js_header .= "<script type='text/javascript' src='". STUDIPORT_JS_URI ."/". $file. "'></script>\n";
}


/* Internal define - define if not already*/
function defDefault($key, $value) {
  if (!defined($key)) {
    define($key, $value);
  }
}

?>
