<?php
/**************************************************************************
 * $Id: StudIPortDownload.php 4351 2010-09-07 08:52:11Z renner $
 *
 * Copyright (C) 2008, 2009, 2010; Hamburg University of Technology
 *
 * > TECHNICAL REALIZATION
 *   Christian Renner <christian.renner@tu-harburg.de>
 *   Leo Krueger
 *   Sigurd Spieckermann
 *
 * > CONCEPT
 *   Peter Baasch
 *   Detlev Bieler
 *   Thomas Czerwionka
 *   Thomas Hapke
 *   Soenke Knutzen
 *   Corinna Peters
 *   Christian Renner
 *   Volker Turau
 *   Olav Wilde
 *
 **************************************************************************
 * This file is part of "StudIPort 2.0 ePortfolio".
 *
 * "StudIPort 2.0 ePortfolio" is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * "StudIPort 2.0 ePortfolio" is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "StudIPort 2.0 ePortfolio".
 * If not, see <http://www.gnu.org/licenses/>.
 *
 *************************************************************************/

// TODO: remove htmlReady in final version
function htmlReady($f) {
	return $f;
}

/* Set internal character encoding to UTF-8 */
mb_internal_encoding("UTF-8");


require_once('config/StudIPort.config.php');

require_once('StudIPortAuth.system.php');
require_once('StudIPortDB.system.php');
require_once('StudIPortUser.system.php');
require_once('StudIPortLinkEngine.system.php');
require_once('StudIPortUtilities.system.php');

require_once('StudIPort.core.php');

require_once('StudIPortAccess.lib.php');

require_once('ext/flexi-templates/flexi.php');

$factory = new Flexi_TemplateFactory(STUDIPORT_TEMPLATES);
$template = $factory->open("StudIPortStandalone.php");

$template->set_attribute('studiport_css_header', $studiport_css_header);
$template->set_attribute('studiport_js_header', $studiport_js_header);

// test authentication
$auth = new StudIPortAuth();

if (! $auth->isLoggedIn()) {
	$template->set_attribute('StudIPortCmd', 'login');
	$template->set_attribute('StudIPortContent', StudIPortAuth::render());
} else {
	if (empty($_REQUEST['cmd'])) {
  		$_REQUEST['cmd'] = 'news';
	}

	$template->set_attribute('StudIPortCmd', $_REQUEST['cmd']);

	$template->set_attribute('StudIPortFullname', StudIPortUser::theUser()->getRealName());

	switch($_REQUEST['cmd']) {
		case 'contact':
			// hier sollte vielleicht noch was hin
			$t = $factory->open("StudIPortContact.page.php");
			$template->set_attribute('StudIPortContent', $t->render());
			break;

		case 'version':
			require_once("Version.class.php");
			$v = new Version();
			$template->set_attribute('StudIPortContent', $v->render());
			break;

		case 'profile':
			require_once("StudIPortProfile.class.php");
			$template->set_attribute('StudIPortContent', StudIPortProfile::render());
			break;

		default:
			StudIPort::getInstance()->render($_REQUEST['cmd'], $factory, $template);
			break;
	}
}

echo $template->render();

?>
