<?php
/**************************************************************************
 * $Id: StudIPort.core.php 4531 2011-01-13 13:04:32Z weyer $
 *
 * Copyright (C) 2008, 2009, 2010; Hamburg University of Technology
 *
 * > TECHNICAL REALIZATION
 *   Christian Renner <christian.renner@tu-harburg.de>
 *   Leo Krueger
 *   Sigurd Spieckermann
 *
 * > CONCEPT
 *   Peter Baasch
 *   Detlev Bieler
 *   Thomas Czerwionka
 *   Thomas Hapke
 *   Soenke Knutzen
 *   Corinna Peters
 *   Christian Renner
 *   Volker Turau
 *   Olav Wilde
 *
 **************************************************************************
 * This file is part of "StudIPort 2.0 ePortfolio".
 *
 * "StudIPort 2.0 ePortfolio" is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * "StudIPort 2.0 ePortfolio" is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "StudIPort 2.0 ePortfolio".
 * If not, see <http://www.gnu.org/licenses/>.
 *
 *************************************************************************/


class StudIPort {
	static private $instance = null;
 
	static public function getInstance() {
		if (null === self::$instance) {
			self::$instance = new self;
		}
		return self::$instance;
	}

	private function __construct() {
		/* void */
	}

	private function __clone() {
		/* void */
	}

	static public function render($page, & $factory, & $template) {
		/* setup depending on requested page */
		switch($page) {
		case 'artefacts':
			if (empty($_REQUEST['file_id'])) {
				require_once("StudIPortPageFileListOwner.class.php");
				$thePage     = new StudIPortPageFileListOwner(StudIPortUser::theUser());
				$theTemplate = 'StudIPortFileList.page.php';
			} else {
				require_once("StudIPortPageFileDetails.class.php");
				$thePage     = new StudIPortPageFileDetails(StudIPortUser::theUser(), $_REQUEST['file_id']);
				$theTemplate = "StudIPortFileDetails.page.php";
			}
			break;

		case 'views':
			if (! empty($_REQUEST['question_id'])) {
				require_once("StudIPortPageQuestionDetails.class.php");
				$thePage     = new StudIPortPageQuestionDetails(StudIPortUser::theUser(), $_REQUEST['question_id']);
				$theTemplate = "StudIPortQuestionDetails.page.php";
			} else if (! empty($_REQUEST['view_id'])) {
				require_once("StudIPortPageViewDetails.class.php");
				$thePage     = new StudIPortPageViewDetails(StudIPortUser::theUser(), $_REQUEST['view_id']);
				$theTemplate = "StudIPortViewDetails.page.php";
			} else {
				require_once("StudIPortPageViewList.class.php");
				$thePage     = new StudIPortPageViewList(StudIPortUser::theUser());
				$theTemplate = "StudIPortViewList.page.php";
			}
			break;

		case 'matrix':
			require_once("StudIPortPageMatrix.class.php");
			$thePage     = new StudIPortPageMatrix(StudIPortUser::theUser());
			$theTemplate = "StudIPortMatrix.page.php";
			break;

		case 'news':
			require_once("StudIPortPageOverview.class.php");
			$thePage     = new StudIPortPageOverview(StudIPortUser::theUser());
			$theTemplate = "StudIPortOverview.page.php";
			break;

		case 'others':
			if (empty($_REQUEST['view_id'])) {
				require_once("StudIPortPageViewListAlien.class.php");
				$thePage     = new StudIPortPageViewListAlien(StudIPortUser::theUser());
				$theTemplate = "StudIPortViewListAlien.page.php";
			} else {
				require_once("StudIPortPageViewAlien.class.php");
				$thePage     = new StudIPortPageViewAlien(StudIPortUser::theUser(), $_REQUEST['view_id']);
				$theTemplate = "StudIPortViewAlien.page.php";
			}
			break;
/*
		case 'contact':
				$thePage     = null;
				$theTemplate = 'StudIPortContact.page.php';
				break;

		case 'version':
				require_once("Version.class.php");
				$thePage = new Version();
				$theTemplate = 'StudIPortVersion.page.php';
				$v = new Version();
				$v->render();

				break;
*/
		default:
			$template->set_attribute('StudIPortContent', '');
			return;
			break;
		}

		/* perform generic actions */
		$thePage->loadData();
		$template->set_attribute(
			'StudIPortContent',
			$thePage->render($factory, $theTemplate));
		$template->set_attribute('infobox', $thePage->renderInfobox($factory));
	}
}

// the instance
global $StudIPort;
$StudIPort = StudIPort::getInstance();
?>
