<?php
/**************************************************************************
 * $Id: StudIPortUploadTools.lib.php 4574 2011-01-18 08:24:51Z renner $
 *
 * Copyright (C) 2008, 2009, 2010; Hamburg University of Technology
 *
 * > TECHNICAL REALIZATION
 *   Christian Renner <christian.renner@tu-harburg.de>
 *   Leo Krueger
 *   Sigurd Spieckermann
 *
 * > CONCEPT
 *   Peter Baasch
 *   Detlev Bieler
 *   Thomas Czerwionka
 *   Thomas Hapke
 *   Soenke Knutzen
 *   Corinna Peters
 *   Christian Renner
 *   Volker Turau
 *   Olav Wilde
 *
 **************************************************************************
 * This file is part of "StudIPort 2.0 ePortfolio".
 *
 * "StudIPort 2.0 ePortfolio" is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * "StudIPort 2.0 ePortfolio" is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "StudIPort 2.0 ePortfolio".
 * If not, see <http://www.gnu.org/licenses/>.
 *
 *************************************************************************/

require_once('StudIPortDB.system.php');

function createUploadKey() {
	return md5(rand() . microtime());
}


function uploadGetCurUsage($userid) {
	$db = new StudIPortDB();
	$db->queryf("SELECT SUM(filesize) as 'usage' FROM studiport_file WHERE user_id='%s'", $userid);
	$db->next_record();

	return $db->f('usage');
}


function uploadGetUsageStat($userid) {
	// get current usage
	$usage = uploadGetCurUsage($userid);

	// calculcate statistics
	$stat = array();
	$stat['curUsagePerc'] = intval(100.0 * $usage / STUDIPORT_FILES_QUOTA);
	$stat['curUsage']     = "Belegung: ". $stat['curUsagePerc'] ."% von ". uploadSizeToString(STUDIPORT_FILES_QUOTA);
	$maxFileSize = min(STUDIPORT_FILES_MAXSIZE, STUDIPORT_FILES_QUOTA - $usage);
	$stat['maxFileSize']       = $maxFileSize;
	$stat['maxFileSizeHuman']  = uploadSizeToString($maxFileSize, 1);

	return $stat;
}


/**
 * Converts a given size (in bytes) to a string with shortest possible approximation
 * appending kB, MB, etc.
 * Example: 1025 Bytes -> 1 kB
 */
function uploadSizeToString($numBytes, $digits = 0) {
	$units = array('Byte', 'kB', 'MB', 'GB');
	foreach ($units as $u) {
		if ($numBytes < 1000) {
			break;
		}
		$numBytes /= 1000.0;
	}

	// rounding with guaranteed number of digits behing the comma
	if ($digits > 0) {
		$shift  = pow(10, $digits);
		$tmp    = round($numBytes * $shift);
		$base   = (int)($tmp / $shift);
		$rem    = (int)($tmp % $shift);
		$numBytes = sprintf("%d,%0{$digits}u", $base, $rem);
	} else {
		$numBytes = round($numBytes);
	}

	return $numBytes .' '. $u;
}

function isValidURL($url) {
/*
	// FIXME the remainder here is more or less insane, as
	// the check will fail for many regular, but strange looking
	// links

	$urlregex = '^((https?|ftp)\:\/\/)?';

	// user/pass
	$urlregex .= "([a-z0-9+!*(),;?&=\$_.-]+(\:[a-z0-9+!*(),;?&=\$_.-]+)?@)?";

	// hostname
	$urlregex .= "[a-z0-9+\$_-]+(\.[a-z0-9+\$_-]+)*";

	// port (optional)
	$urlregex .= "(\:[0-9]{2,5})?";

	// path (optional)
	$urlregex .= "(\/([a-z0-9+\$_-~]\.?)+)*\/?";

	// GET query (optional)
	$urlregex .= "(\?[a-z+&\$_.-][a-z0-9;:@/&%=+\$_.-]*)?";

	// anchor (optional)
	$urlregex .= "(#[a-z_.-][a-z0-9+\$_.-]*)?\$";

	if (! (bool) eregi($urlregex, $url)) {
		return 1;
	}
*/
	
	if (is_null(parse_url($url, PHP_URL_SCHEME))) {
		$url = 'http://' . $url;
	}

	$headers = get_headers($url);
	
	
//	if ($headers[0] != 'HTTP/1.0 200 OK') {
	if ($headers === false || eregi(" [45][0-9]{2}", $headers[0])) {
		return 2;
	}
	
	return 0;
}

?>
