<?php
/**************************************************************************
 * $Id: StudIPortViewTools.lib.php 4429 2010-11-15 12:40:37Z weyer $
 *
 * Copyright (C) 2008, 2009, 2010; Hamburg University of Technology
 *
 * > TECHNICAL REALIZATION
 *   Christian Renner <christian.renner@tu-harburg.de>
 *   Leo Krueger
 *   Sigurd Spieckermann
 *
 * > CONCEPT
 *   Peter Baasch
 *   Detlev Bieler
 *   Thomas Czerwionka
 *   Thomas Hapke
 *   Soenke Knutzen
 *   Corinna Peters
 *   Christian Renner
 *   Volker Turau
 *   Olav Wilde
 *
 **************************************************************************
 * This file is part of "StudIPort 2.0 ePortfolio".
 *
 * "StudIPort 2.0 ePortfolio" is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * "StudIPort 2.0 ePortfolio" is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "StudIPort 2.0 ePortfolio".
 * If not, see <http://www.gnu.org/licenses/>.
 *
 *************************************************************************/

require_once('StudIPortDB.system.php');

/**
 * get access list of provided view
 * @param
 * @return access list as associative array
 */
function getStudIPortViewAccessList ($view_id) {
	$userLst = array();
	$idLst   = array();

	// make it an int
	$view_id = intval($view_id);

	// double-check it's not empty
	if (! empty($view_id)) {
		// establish DB connection
		$sql = new StudIPortDB();

		// obtain data for given view
		$sql->queryf("SELECT DISTINCT user_id FROM studiport_view_access WHERE view_id=%u", $view_id);
                while ($sql->next_record()) {
                        array_push($idLst, $sql->f('user_id'));
                }
	}

	StudIPortUser::getByUserId($userLst, $idLst);
	return $userLst;
}


function viewGetBasics($view_id) {
	$db = new StudIPortDB();
	$db->queryf("SELECT view_id, name, descr, IF(expires, DATE_FORMAT(expires, '%%d.%%m.%%Y'), '---') as expires, IF(expires,expires<CURDATE(),FALSE) as expired, DATE_FORMAT(created, '%%d.%%m.%%Y %%k:%%i Uhr') as created, DATE_FORMAT(edited, '%%d.%%m.%%Y %%k:%%i Uhr') as edited, public, access_code FROM studiport_view WHERE view_id='%u'", $view_id);
	if ($db->num_rows() == 0) {
		return null;
	}
	$db->next_record();
	return $db->get_record();
}


function viewCreateNewAccessCode() {
	return md5(rand() . microtime());
}


function viewGetExtAccessLink() {
	return STUDIPORT_EXT_ACCESS_URI;
}
?>
