<?php
/**************************************************************************
 * $Id: $
 *
 * Copyright (C) 2008, 2009, 2010; Hamburg University of Technology
 *
 * > TECHNICAL REALIZATION
 *   Christian Renner <christian.renner@tu-harburg.de>
 *   Leo Krueger
 *   Sigurd Spieckermann
 *
 * > CONCEPT
 *   Peter Baasch
 *   Detlev Bieler
 *   Thomas Czerwionka
 *   Thomas Hapke
 *   Soenke Knutzen
 *   Corinna Peters
 *   Christian Renner
 *   Volker Turau
 *   Olav Wilde
 *
 **************************************************************************
 * This file is part of "StudIPort 2.0 ePortfolio".
 *
 * "StudIPort 2.0 ePortfolio" is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * "StudIPort 2.0 ePortfolio" is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "StudIPort 2.0 ePortfolio".
 * If not, see <http://www.gnu.org/licenses/>.
 *
 *************************************************************************/

require_once('StudIPortFiles.class.php');
require_once('StudIPortFileTools.lib.php');


// FIXME this is wrong derivation
class StudIPortMatrix extends StudIPortFiles
{
	// get visible cols and rows for matrix
        protected function getHeaderData() {
                $sql =& $this->sql;

                // get competence/rows headers
                $sql->queryf("SELECT comp_id as id, title, descr FROM `studiport_matrix_comp`
                                         WHERE comp_id NOT IN
                                         (SELECT comp_id FROM studiport_matrix_comp_hide WHERE user_id = '%s')
                                         ORDER BY pos ASC", $this->user->getUserId());

                $this->comp = NULL;
                $this->saveSqlData($sql, $this->comp);

                // get experience/cols headers
                $sql->queryf("SELECT exp_id as id, title, descr FROM `studiport_matrix_exp`
                                         WHERE exp_id NOT IN
                                         (SELECT exp_id FROM studiport_matrix_exp_hide WHERE user_id = '%s')
                                         ORDER BY pos ASC", $this->user->getUserId());

                $this->exp = NULL;
                $this->saveSqlData($sql, $this->exp);
        }


	/** loads data for matrix
	 */
	public function loadData() {
		parent::loadData();

		// get reference to db object for better readability
		$sql =& $this->sql;

		// get associated files
		$sql->queryf("SELECT comp_id, exp_id, type_id, COUNT(*) as num
						FROM studiport_file
						LEFT JOIN studiport_file_assoc USING (file_id)
						WHERE user_id = '%s'
						GROUP BY comp_id, exp_id, type_id", $this->user->getUserId());

		while ($sql->next_record()) {
			$this->data[$sql->f("comp_id")][$sql->f("exp_id")][$sql->f("type_id")] = $sql->f("num");
		}

		// get cell comments
		$sql->queryf("SELECT comp_id, exp_id,
                        IF(LENGTH(text_int) > 0 && LENGTH(text_ext) > 0, 'yes',
                        	IF(LENGTH(text_int) > 0, 'int',
								IF(LENGTH(text_ext) > 0, 'ext', 'no')
							)
						) as text
						FROM studiport_matrix_cell_descr
						WHERE user_id = '%s'", $this->user->getUserId());
		while ($sql->next_record()) {
			$this->data[$sql->f("comp_id")][$sql->f("exp_id")]["text"] = $sql->f("text");
		}
	}

	/**
	 * @see StudIPortPage::render()
	 */
	public function render(Flexi_TemplateFactory &$factory, $templateFilename) {
		parent::render($factory, $templateFilename);

		$this->template->set_attribute('rows', $this->comp);
		$this->template->set_attribute('cols', $this->exp);
		$this->template->set_attribute('types', $this->types);
		$this->template->set_attribute('matrixData', $this->data);
		$this->template->set_attribute('upload', uploadGetUsageStat($this->user->getUserId()));

		$noAssoc = filesGetNoAssocList();
		$this->template->set_attribute('fileData', $noAssoc["htmlContent"]);

		return $this->template->render();
	}
}
?>
