<?php
/**************************************************************************
 * $Id: $
 *
 * Copyright (C) 2008, 2009, 2010; Hamburg University of Technology
 *
 * > TECHNICAL REALIZATION
 *   Christian Renner <christian.renner@tu-harburg.de>
 *   Leo Krueger
 *   Sigurd Spieckermann
 *
 * > CONCEPT
 *   Peter Baasch
 *   Detlev Bieler
 *   Thomas Czerwionka
 *   Thomas Hapke
 *   Soenke Knutzen
 *   Corinna Peters
 *   Christian Renner
 *   Volker Turau
 *   Olav Wilde
 *
 **************************************************************************
 * This file is part of "StudIPort 2.0 ePortfolio".
 *
 * "StudIPort 2.0 ePortfolio" is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * "StudIPort 2.0 ePortfolio" is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "StudIPort 2.0 ePortfolio".
 * If not, see <http://www.gnu.org/licenses/>.
 *
 *************************************************************************/

require_once('ext/flexi-templates/flexi.php');
require_once('StudIPortPage.class.php');
require_once('StudIPortFileTools.lib.php');
require_once('StudIPortUploadTools.lib.php');

// this must be a child of StudIPortFiles
class StudIPortPageFileDetails extends StudIPortPage
{
	protected $data   = array();
	protected $fileId = null;
	protected $views  = array();

	public function __construct(StudIPortUser &$user, $fileId) {
		parent::__construct($user);
		$this->fileId = $fileId;
	}

	public function loadData() {
                // sanity check to ensure that file belongs to user
                if (! validateFileAccess($this->fileId, $this->user->getUserId(), $res)) {
                        // TODO error message
                        $this->data = null;
                        return;
                }



		// get data from db
		$this->data = fileGetDetails($this->fileId);
		if ($this->data == null) {
			$this->data['error'] = 'Es existiert keine Datei zu der angegebenen ID.';
		} else {
			$sql =& $this->sql;
			
			// THIS IS A MESS	
			$sql->queryf(
				  " SELECT"
				. "   view_id,"
				. "   name,"
				. "   public,"
				. "   CHAR_LENGTH(descr) > 0 AS hasInfo,"
				. "   IF( (SELECT COUNT(*) FROM studiport_view_files"
				. "        WHERE view_id=v.view_id AND file_id='%u' ) > 0, 'Y', 'N') AS hasFile,"
				. "   ( SELECT COUNT(*) FROM studiport_view_access"
				. "     WHERE view_id=v.view_id ) AS numAccess"
				. " FROM studiport_view AS v"
				. " WHERE user_id='%s'",
				$this->fileId, $this->user->getUserId()); 
			/*$sql->query("SELECT    view_id," .
			            "          IF(SUM(IF(file_id='" . $file_id_esc . "', 1, 0)) > 0, 'Y', 'N') AS hasFile," .
			            "          name," .
			            "          public, " .
			            "          CHAR_LENGTH(descr) > 0 AS hasInfo " .
			            "FROM      studiport_view AS v" . 
			            "LEFT JOIN studiport_view_files USING (view_id) " . 
			            "WHERE     user_id = '" . $user_esc . "' " . 
			            "GROUP BY  view_id");
			*/
			
			while ($sql->next_record()) {
				$pointer =& $this->views[$sql->f('view_id')];

				$pointer = $sql->get_record();
			}
		}
	}

	/**
 	* @param id file id from studiport_files table
 	*/
	public function render(Flexi_TemplateFactory &$factory, $templateFilename) {
		parent::render($factory, $templateFilename);
			
		$this->template->set_attribute('data',  $this->data);
		$this->template->set_attribute('views', $this->views);
		
		return $this->template->render();
	}
}
?>
