<?php
/**************************************************************************
 * $Id: $
 *
 * Copyright (C) 2008, 2009, 2010; Hamburg University of Technology
 *
 * > TECHNICAL REALIZATION
 *   Christian Renner <christian.renner@tu-harburg.de>
 *   Leo Krueger
 *   Sigurd Spieckermann
 *
 * > CONCEPT
 *   Peter Baasch
 *   Detlev Bieler
 *   Thomas Czerwionka
 *   Thomas Hapke
 *   Soenke Knutzen
 *   Corinna Peters
 *   Christian Renner
 *   Volker Turau
 *   Olav Wilde
 *
 **************************************************************************
 * This file is part of "StudIPort 2.0 ePortfolio".
 *
 * "StudIPort 2.0 ePortfolio" is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * "StudIPort 2.0 ePortfolio" is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "StudIPort 2.0 ePortfolio".
 * If not, see <http://www.gnu.org/licenses/>.
 *
 *************************************************************************/

require_once('StudIPortPage.class.php');
require_once('StudIPortMatrix.class.php');
require_once('StudIPortDB.system.php');


class StudIPortPageMatrix extends StudIPortPage
{
        protected $matrix;

        public function loadData() {
                $this->matrix = new StudIPortMatrix($this->user);
                $this->matrix->loadData();
        }

        public function render(Flexi_TemplateFactory &$factory, $templateFilename) {
                parent::render($factory, $templateFilename);

		// TODO ???
                //$this->template->set_attribute('matrix', $this->matrix->render($factory, "StudIPortMatrix.part.php"));
                return $this->matrix->render($factory, "StudIPortMatrix.page.php");

                //return $this->template->render();
        }

	/** collects some data from database and builds array for infobox
	 * @see StudIPortPage::renderInfobox()
	 * @param void
	 */
	public function renderInfobox(Flexi_TemplateFactory &$factory) {
		// get hidden columns
		$db = new StudIPortDB(
			"SELECT exp_id, title FROM studiport_matrix_exp_hide ".
			"LEFT JOIN studiport_matrix_exp USING (exp_id) ".
			"WHERE user_id = '". $this->user->getUserId() ."'");

		while ($db->next_record()) {
			$hiddenExp[] = $db->get_record();
		}

		// get hidden rows
		$db = new StudIPortDB(
			"SELECT comp_id, title FROM studiport_matrix_comp_hide ".
			"LEFT JOIN studiport_matrix_comp USING (comp_id) ".
			"WHERE user_id = '". $this->user->getUserId() ."'");

		while ($db->next_record()) {
			$hiddenComp[] = $db->get_record();
		}

		// assign attributes
		$template = $factory->open("StudIPortMatrix.infobox.php");
		if (! empty($hiddenExp)) {
			$template->set_attribute('hiddenExp',  $hiddenExp);
		}
		if (! empty($hiddenComp)) {
			$template->set_attribute('hiddenComp', $hiddenComp);
		}

		// render
		return $template->render();
	}
}
?>
