<?php
/**************************************************************************
 * $Id: $
 *
 * Copyright (C) 2008, 2009, 2010; Hamburg University of Technology
 *
 * > TECHNICAL REALIZATION
 *   Christian Renner <christian.renner@tu-harburg.de>
 *   Leo Krueger
 *   Sigurd Spieckermann
 *
 * > CONCEPT
 *   Peter Baasch
 *   Detlev Bieler
 *   Thomas Czerwionka
 *   Thomas Hapke
 *   Soenke Knutzen
 *   Corinna Peters
 *   Christian Renner
 *   Volker Turau
 *   Olav Wilde
 *
 **************************************************************************
 * This file is part of "StudIPort 2.0 ePortfolio".
 *
 * "StudIPort 2.0 ePortfolio" is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * "StudIPort 2.0 ePortfolio" is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "StudIPort 2.0 ePortfolio".
 * If not, see <http://www.gnu.org/licenses/>.
 *
 *************************************************************************/

require_once('StudIPortPage.class.php');

require_once('StudIPortViewList.class.php');
require_once('StudIPortQuestionList.class.php');
require_once('StudIPortViewListAlien.class.php');


class StudIPortPageOverview extends StudIPortPage
{
	protected $myResponses;                 // feedback responses addressed to me
	protected $myViewsExpire;               // view that will expire soon
	protected $myQuestionsExpire;           // questions that will expire soon

	protected $theirViewsNew;               // new views for me
	protected $theirViewsModified;          // modified views that I have access to
	protected $theirQuestionsOpen;          // unanswered questions addressed to me

/*
	protected $views = array();
	protected $viewsEdited = array();
	protected $responses = array();
	protected $requests = array();
	protected $no_other = true;
	protected $viewExpires = array();
	protected $questExpires = array();
*/

	public function loadData() {
		// my portfolio	
		$this->myResponses = new StudIPortViewList($this->user);
		$this->myResponses->loadData(constant('StudIPortViewList::FILTER_NEW_FEEDBACK'));

		$this->myViewsExpire = new StudIPortViewList($this->user);
		$this->myViewsExpire->loadData(constant('StudIPortViewList::FILTER_EXPIRE'));

		$this->myQuestionsExpire = new StudIPortQuestionList($this->user);
		$this->myQuestionsExpire->loadData(constant('StudIPortQuestionList::FILTER_EXPIRE'));


		// other portfolios
		$this->theirViewsNew = new StudIPortViewListAlien($this->user);
		$this->theirViewsNew->loadData(constant('StudIPortViewListAlien::FILTER_NEW'));
		
		$this->theirViewsModified = new StudIPortViewListAlien($this->user);
		$this->theirViewsModified->loadData(constant('StudIPortViewListAlien::FILTER_MODIFIED'));
		
//		$this->theirQuestions = new StudIPortQuestionList($this->user);
//		$this->theirQuestions->loadData(constant('StudIPortQuestionList::FILTER_NEW'));
	}
	
	public function render(Flexi_TemplateFactory &$factory, $templateFilename) {
		parent::render($factory, $templateFilename);
		
	
		// my portfolio	
		$this->myResponses->setStyle(STUDIPORT_STYLE_NESTED);
		$this->template->set_attribute('myResponses',    $this->myResponses->render($factory, "StudIPortViewList.part.php"));
		$this->template->set_attribute('numMyResponses', $this->myResponses->getNum());

		$this->myViewsExpire->setStyle(STUDIPORT_STYLE_NESTED);
		$this->template->set_attribute('myViewsExpire',    $this->myViewsExpire->render($factory, "StudIPortViewList.part.php"));
		$this->template->set_attribute('numMyViewsExpire', $this->myViewsExpire->getNum());
		
		$this->myQuestionsExpire->setStyle(STUDIPORT_STYLE_NESTED);
		$this->template->set_attribute('myQuestionsExpire',    $this->myQuestionsExpire->render($factory, "StudIPortQuestionList.part.php"));
		$this->template->set_attribute('numMyQuestionsExpire', $this->myQuestionsExpire->getNum());


		// other portfolios
		$this->template->set_attribute('theirViewsNew', $this->theirViewsNew->render($factory, "StudIPortViewListAlien.part.php"));
		$this->template->set_attribute('numTheirViewsNew', $this->theirViewsNew->getNum());

		$this->template->set_attribute('theirViewsModified', $this->theirViewsModified->render($factory, "StudIPortViewListAlien.part.php"));
		$this->template->set_attribute('numTheirViewsModified', $this->theirViewsModified->getNum());

//		$this->template->set_attribute('theirQuestionsOpen', $this->theirQuestionsOpen->render($factory, "StudIPortQuestionList.part.php"));
//		$this->template->set_attribute('numTheirQuestionsOpen', $this->theirQuestionsOpen->getNum());


		return $this->template->render();
	}
}
