<?php
/**************************************************************************
 * $Id: $
 *
 * Copyright (C) 2008, 2009, 2010; Hamburg University of Technology
 *
 * > TECHNICAL REALIZATION
 *   Christian Renner <christian.renner@tu-harburg.de>
 *   Leo Krueger
 *   Sigurd Spieckermann
 *
 * > CONCEPT
 *   Peter Baasch
 *   Detlev Bieler
 *   Thomas Czerwionka
 *   Thomas Hapke
 *   Soenke Knutzen
 *   Corinna Peters
 *   Christian Renner
 *   Volker Turau
 *   Olav Wilde
 *
 **************************************************************************
 * This file is part of "StudIPort 2.0 ePortfolio".
 *
 * "StudIPort 2.0 ePortfolio" is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * "StudIPort 2.0 ePortfolio" is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "StudIPort 2.0 ePortfolio".
 * If not, see <http://www.gnu.org/licenses/>.
 *
 *************************************************************************/

require_once("StudIPortAuth.iface.php");

require_once("StudIPortDB.system.php");


class StudIPortAuth extends Iface_StudIPortAuth {

	private static function destroySession() {
		//destroy session
		unset($_SESSION['auth']);
		unset($_SESSION['user_id']);
		unset($_SESSION['timeout_idle']);
	}

	public function __construct() {
		session_name('StudIPort');
		session_start();
		// for security reasons: register_globals must be disabled
		if (isset($_REQUEST['_SESSION'])) die("for security reasons: register_globals must be disabled");

		// test for login mechnism
		if (empty($_SESSION['auth']) || empty($_SESSION['user_id'])) {
			if (! empty($_REQUEST['user']) && ! empty($_REQUEST['password'])) {
				$user_id = StudIPortUser::authenticate($_REQUEST['user'], $_REQUEST['password']);
				if ($user_id === false) {
 					echo "Unknown User/Password";
				} else {
					$_SESSION['auth'] = true;
					$_SESSION['user_id'] = $user_id;
				}
			} else {
				//destroy session
				self::destroySession();
			}
		} else {
			if (! empty($_REQUEST['logout'])) {
				//destroy session
				self::destroySession();
			} else {
				if (!isset($_SESSION['timeout_idle'])) {
					$_SESSION['timeout_idle'] = time() + STUDIPORT_SESSION_TIMEOUT;
				} else {
					if ($_SESSION['timeout_idle'] < time()) {   
						//destroy session
						self::destroySession();
					} else {
						$_SESSION['timeout_idle'] = time() + STUDIPORT_SESSION_TIMEOUT;
					}
				}
			}
		}
	}

	public function isLoggedIn($haltOnDeny = false) {
		if ($haltOnDeny) {
			if ((! empty($_SESSION['auth']) && ($_SESSION['auth'] === true))) {
				return true;
			} else {
				die("return to login page");
			}
		} else {
			if ((! empty($_SESSION['auth']) && ($_SESSION['auth'] === true))) {
				return true;
			} else {
				return false;
			}
		}
	}

	public static function render() {
		//session_regenerate_id();
		$page  = "<form action='.' method='post'>\n";
		$page .= "  Benutzername : <input name='user' type='text' size='30' maxlength='30' /> <br />\n";
		$page .= "  Passwort : <input name='password' type='password' size='30' maxlength='30' /><br />\n";
		$page .= "  <input type='submit' value='Anmelden' />\n";
		$page .= "</form>\n";
		return $page;
	}
};

?>
