<?php
/**************************************************************************
 * $Id: $
 *
 * Copyright (C) 2008, 2009, 2010; Hamburg University of Technology
 *
 * > TECHNICAL REALIZATION
 *   Christian Renner <christian.renner@tu-harburg.de>
 *   Leo Krueger
 *   Sigurd Spieckermann
 *
 * > CONCEPT
 *   Peter Baasch
 *   Detlev Bieler
 *   Thomas Czerwionka
 *   Thomas Hapke
 *   Soenke Knutzen
 *   Corinna Peters
 *   Christian Renner
 *   Volker Turau
 *   Olav Wilde
 *
 **************************************************************************
 * This file is part of "StudIPort 2.0 ePortfolio".
 *
 * "StudIPort 2.0 ePortfolio" is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * "StudIPort 2.0 ePortfolio" is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "StudIPort 2.0 ePortfolio".
 * If not, see <http://www.gnu.org/licenses/>.
 *
 *************************************************************************/

require_once("StudIPortAuth.iface.php");


class StudIPortAuth extends Iface_StudIPortAuth {

	public function __construct() {
		global $sess, $auth, $perm, $user;

		page_open(
			array(
				'sess' => 'Seminar_Session',
				'auth' => 'Seminar_Default_Auth',
				'perm' => 'Seminar_Perm',
				'user' => 'Seminar_User'
			));
	}

	public function isLoggedIn($haltOnDeny = false) {
		global $sess, $auth, $perm, $user;

		if ($haltOnDeny) {
			// FIXME show log-in page instead
			if (! $auth->is_authenticated()) {
				die('Should not reach this line of code');
			}
		} else {
			return $auth->is_authenticated();
		}
	}
};

?>
