<?php
/**************************************************************************
 * $Id: $
 *
 * Copyright (C) 2008, 2009, 2010; Hamburg University of Technology
 *
 * > TECHNICAL REALIZATION
 *   Christian Renner <christian.renner@tu-harburg.de>
 *   Leo Krueger
 *   Sigurd Spieckermann
 *
 * > CONCEPT
 *   Peter Baasch
 *   Detlev Bieler
 *   Thomas Czerwionka
 *   Thomas Hapke
 *   Soenke Knutzen
 *   Corinna Peters
 *   Christian Renner
 *   Volker Turau
 *   Olav Wilde
 *
 **************************************************************************
 * This file is part of "StudIPort 2.0 ePortfolio".
 *
 * "StudIPort 2.0 ePortfolio" is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * "StudIPort 2.0 ePortfolio" is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "StudIPort 2.0 ePortfolio".
 * If not, see <http://www.gnu.org/licenses/>.
 *
 *************************************************************************/


require_once("StudIPortDB.iface.php");


class StudIPortDB extends Iface_StudIPortDB {
	protected $db;

	public function __construct($q = false) {
		$this->db =& new DB_Seminar($q);
	}

	public function query($q) {
		return $this->db->query($q);
	}

	public function escape($v) {
		// if there is a connection link to the database, escape chars
		if (isset($this)                         &&
		    method_exists($this->db, "link_id")  &&
		    is_resource($this->db->link_id())    &&
		    strcasecmp('mysql link', get_resource_type($this->db->link_id())))
		{
			return @mysql_real_escape_string($v);
		} else {
			// if we can't use the above, at least introduce "some" security
			// however, the whole DB system should be altered to use PDO with
			// prepared statements
			return addslashes($v);
		}
	}

        // convert a string from UTF8 to DB character set - StudIPortDB::convertToDB
        public static function convertToDB($v) {
                return utf8_decode($v);
        }

        // convert a string from DB character set to UTF8 - StudIPortDB::convertFromDB
        public static function convertFromDB($v) {
                return utf8_encode($v);
        }


	public function next_record() {
		return $this->db->next_record();
	}

	public function get_record() {
		return $this->db->Record;
	}
	
	public function f($fn) {
		return $this->db->f($fn);
	}

	public function num_rows() {
		return $this->db->num_rows();
	}

	public function cur_row() {
		return $this->db->Row;
	}

	public function affected_rows() {
		return $this->db->affected_rows();
	}
};

?>
