<?php
/**************************************************************************
 * $Id: $
 *
 * Copyright (C) 2008, 2009, 2010; Hamburg University of Technology
 *
 * > TECHNICAL REALIZATION
 *   Christian Renner <christian.renner@tu-harburg.de>
 *   Leo Krueger
 *   Sigurd Spieckermann
 *
 * > CONCEPT
 *   Peter Baasch
 *   Detlev Bieler
 *   Thomas Czerwionka
 *   Thomas Hapke
 *   Soenke Knutzen
 *   Corinna Peters
 *   Christian Renner
 *   Volker Turau
 *   Olav Wilde
 *
 **************************************************************************
 * This file is part of "StudIPort 2.0 ePortfolio".
 *
 * "StudIPort 2.0 ePortfolio" is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * "StudIPort 2.0 ePortfolio" is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "StudIPort 2.0 ePortfolio".
 * If not, see <http://www.gnu.org/licenses/>.
 *
 *************************************************************************/


require_once("StudIPortLinkEngine.iface.php");
require_once("lib/plugins/engine/PluginEngine.class.php");
require_once("lib/classes/URLHelper.php");


class StudIPortLinkEngine extends Iface_StudIPortLinkEngine {
	// page to display
	// additional params as assoc array
	// return urlencoded link
	public static function getLink($page, $params = array()) {
		if (! is_array($params)) {
			$params = array();
			// FIXME ERROR MSG or WARNING
		}
		if (! empty($page)) {
			$params['plugin_subnavi_params'] = $page;
		}

		if (! empty($GLOBALS['plugin'])) {
			return PluginEngine::getLink($GLOBALS['plugin'], $params, NULL);
		} else {
			// NOTE we cannot access the plugin, so try to do this manually
			// this is needed for AJAX requests
			$studip_relative_path = substr(STUDIPORT_URI, 0, -strlen('/plugins_packages' . STUDIPORT_RELATIVE_PATH));
			UrlHelper::setBaseURL($studip_relative_path);
			$url = "plugins.php/". strtolower(STUDIPORT_PLUGIN_CLASS);
			return URLHelper::getLink($url, $params);
		}
	}
};

?>
