<?php
/**************************************************************************
 * $Id: $
 *
 * Copyright (C) 2008, 2009, 2010; Hamburg University of Technology
 *
 * > TECHNICAL REALIZATION
 *   Christian Renner <christian.renner@tu-harburg.de>
 *   Leo Krueger
 *   Sigurd Spieckermann
 *
 * > CONCEPT
 *   Peter Baasch
 *   Detlev Bieler
 *   Thomas Czerwionka
 *   Thomas Hapke
 *   Soenke Knutzen
 *   Corinna Peters
 *   Christian Renner
 *   Volker Turau
 *   Olav Wilde
 *
 **************************************************************************
 * This file is part of "StudIPort 2.0 ePortfolio".
 *
 * "StudIPort 2.0 ePortfolio" is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * "StudIPort 2.0 ePortfolio" is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "StudIPort 2.0 ePortfolio".
 * If not, see <http://www.gnu.org/licenses/>.
 *
 *************************************************************************/

require_once('StudIPortUser.iface.php');

class StudIPortUser extends Iface_StudIPortUser {
	protected $user_;

	public function __construct($user_id = false) {
		$this->user_ =& new StudIPUser();
		if ($user_id) {
			$this->user_->setUserId($user_id);
		}
/*
		if ($user_id) {
			$this->user_ =& new StudIPUser($user_id);
		} else {
			// try to create user from external data ...
			$this->user_ =& new StudIPUser();
			//$this->user =& $GLOBALS['user'];
		}
		// FIXME ASSERT
*/
	}

	// return user id
	public function getUserId() {
		return $this->user_->getUserId();
	}
	
	// return 
	public function getRealName($rev = true) {
		return self::getRealNameOf($this->getUserId(), $rev);
	}


	public static function getRealNameOf($user_id, $rev = true) {
// TODO could be done by exploting the StudIP user herself
		global $_fullname_sql;
		$db = new StudIPortDB();
		$nf = $rev ? $_fullname_sql['no_title_rev'] : $_fullname_sql['no_title'];
		$db->queryf("SELECT ". $nf ." AS fullname, visible FROM auth_user_md5 WHERE user_id = '%s'", $user_id);
		$db->next_record();
		return $db->f('fullname');;
	}

	// search/find users by name
	public static function searchByName(& $lst, $query, $limit = -1) {
		// TODO fullname search does not work, e.g., "Max Mustermann"
		global $_fullname_sql;
		$db = new StudIPortDB();

		// search in lastname and given name, split query at whitespaces
		$tokLst = split(' +', $query);
		if (count($tokLst) <= 0) {
			return -1;
		}
		$whereClause = "";
		$first = true;
		foreach ($tokLst as $tok) {
			if (! $first) {
				$whereClause .= " OR ";
			} else {
				$first = false;
			}
			$tok = $db->escape($tok);
			$whereClause .= "Nachname LIKE '%$tok%' OR Vorname LIKE '%$tok%'";
		}

		// limit number of results, if desired
		$limit = intval($limit);
		$limitClause = ($limit > 0) ? "LIMIT $limit": '';

		// get results
		$db->query("SELECT user_id, username, ". $_fullname_sql['no_title_rev'] ." AS fullname, visible FROM auth_user_md5 WHERE ". $whereClause ." ORDER BY fullname ". $limClause);

		$lst = array();
		while ($db->next_record()) {
			$lst[] = $db->get_record();
		}

		return count($lst);
	}


	public static function getByUserId(& $lst, $idLst) {
		// check parameter idLst
		if (! is_array($idLst)) {
			$idLst = array($idLst);  // convert to array for ease of use
		}
/* TODO future work
		if (! array_isId($idLst)) {      // make sure, there are only IDs in the array
			return -1;
		}
*/

		// convert array to list
		$idLst = array_unique($idLst);                                // throw out duplicates
		$idLst = array_map(array('StudIPortDB', 'escape'), $idLst);   // escape before DB call
		$idLst = "'". join("', '", $idLst) ."'";

		// obtain data
		global $_fullname_sql;
		$db = new StudIPortDB();
		$db->query("SELECT user_id, username, ". $_fullname_sql['no_title_rev'] ." AS fullname, visible FROM auth_user_md5 WHERE user_id IN (". $idLst .") ORDER BY fullname");

		// put data in list/array
		$lst = array();
		while ($db->next_record()) {
			$lst[] = $db->get_record();
		}

		return count($lst);
	}
};

?>
