StudIPort.ajax =
{
	/** perform an ajax-request
	 *
	 * @param params to be passed to server
	 * @param success function to be called if request is successful
	 * @param failure function to be called if request fails
	 */
	request : function(params, success, failure)
	{
		//  add (box) session id to params
		params.session = StudIPort.box.sessionID;
		
		// start ajax request
		new Ajax.Request(StudIPort.urlAjaxServer, {
			method: "post",
			requestHeaders: {Accept: 'application/json'},
			parameters: params,
			onSuccess:  function(transport)
			{
				// get response
				res = transport.responseJSON;
				
				// decide which function to call
				if (res.success) {
					funcToCall = success;
				} else {
					funcToCall = failure;
				}
				
				// check if it's really a function
				if (typeof funcToCall == 'function')
				{
					// call it
					funcToCall(res, params);
				}
			},
			onFailure: function(transport)
			{
				errorMsg = "Es ist ein Fehler aufgetreten!";
				
				// catch special error codes
				if (400 <= transport.status)
				{
					errorMsg += "<br /><i>Beschreibung: Konnte keine Verbindung zum Server herstellen</i>";
				} else {
					errorMsg += "<br /><i>Beschreibung: unbekannter Fehler, versuchen Sie es spter erneut</i>";
				}

				// do something to inform user
				StudIPort.msgBox.update("superSpecialErrorBox", errorMsg, StudIPort.msgBox.ERROR);
				
				// call failure
				if (typeof failure == 'function') 
				{
					failure(null, params, false);
				}
			}
		});
	}
};
