StudIPort.cache =
{
	data : {},	// data storage
	
	/** builds an index from given keys
	 *
	 * @param key_1
	 * @param key_2
	 * @param key_3 optional
	 */
	buildIndex : function(key_1, key_2, key_3)
	{
		if (key_3 == null) {
			key_3 = "N";
		}
		
		return key_1 + "," + key_2 + "," + key_3;
	},
	
	/** checks wether a cached entry exists for given key
	 * @param indexStr cache index
	 */
	exists : function(indexStr)
	{
		return (this.data[indexStr] == undefined) ? false : true;
	},
	
	/** updates a cache entry or inserts a new one
	 * @param indexStr cache index
	 * @param content to store in cache
	 */
	update : function(indexStr, content)
	{
		this.data[indexStr] = content;
	},

	/** returns content of requested cache entry
	 * @param indexStr cache index
	 */
	get : function(indexStr)
	{
		return this.exists(indexStr) ? this.data[indexStr] : '';
	},
	
	/** deletes cache entry
	 * @param indexStr cache index
	 */
	del : function(indexStr)
	{
		if (this.exists(indexStr)) {
			delete this.data[indexStr];
		}
	}
};
