StudIPort.msgBox =
{
	WAITING : 0,  // idle or waiting for AJAX response
	CHANGED : 1,  // data has been changed
	OK      : 2,  // AJAX response is ok and the request was successful
	WARNING : 3,  // AJAX request succeeded, but warnings were issued
	ERROR   : 4,  // AJAX request could not be handled by server
	COLORS  : Array('#ced2d8', '#fff0b0', '#44a044', '#d08000', '#cc4444'),
	
	/**
	 * update content and display style of a message box
	 *
	 * @param msgBox  handle to or identifier of a message box
	 * @param msgs    message (or array of messages) to be displayed
	 * @param msgType type of message(s), e.g. MSGBOX_OK
	 */
	update : function(id, msgs, msgType)
	{
		// sanity checks
		if (msgType < this.WAITING || msgType > this.ERROR)
		{
			return;
		}

		// get box
		obj = $(id);
		
		if (obj == null)
		{
			return;
		}

		// set style
		//msgBox.className = style;

		// update msgbox content
		if (msgs instanceof Array)
		{	
			obj.update(msgs.join(' '));
		}
		else
		{
			if (msgs.length == 0)
			{
				// workaround, content isn't cleared else
				// this also ensures that the box doesn't shrink!
				msgs = "&nbsp;";
			}
			
			obj.update(msgs);
		}

		// highlight message box, if state is not waiting
		if (msgType == this.WAITING)
		{
			obj.style.backgroundColor = this.COLORS[this.WAITING];
		}
		else if (msgType == this.CHANGED)
		{
			obj.style.backgroundColor = this.COLORS[this.CHANGED];
		}
		else
		{
			new Effect.Highlight(obj, {
				startcolor   : this.COLORS[msgType],
				endcolor     : this.COLORS[this.WAITING],
				restorecolor : this.COLORS[this.WAITING],
				duration     : 2.5
			});
		}
	}
};