<?php

require_once(dirname(__FILE__) . '/../config/StudIPort.config.php');
require_once('StudIPortDB.system.php');

class Initial extends Migration
{
  function description ()
  {
    return 'initial StudIPort install';
  }

  function up ()
  {
    $db = new StudIPortDB();

    // create upload folder
    echo "<br />Creating upload folder '". STUDIPORT_DOWNLOAD_DIR ."' ... ";
    if (! file_exists(STUDIPORT_DOWNLOAD_DIR)) {
      $dirOk = mkdir(STUDIPORT_DOWNLOAD_DIR, 0770);
    } else {
      $dirOk = true;
    }
    echo $dirOk ? "OK" : "FAIL";

    // load static data into database
    echo "<br />Loading static data into database ... ";
    $data_sql = dirname(__FILE__) . "/../sql/studiport_data.sql";
//    $db->query("\\. $data_sql");
    $statements = split(";[[:space:]]*\n", file_get_contents($data_sql));
    foreach ($statements as $statement) {
      $db->query($statement);
    }

    // FIXME this indicator isn't quite perfect
    $dbOk = ($db->affected_rows() > 0) ? true : false;
    echo $dbOk ? "OK" : "FAIL";

    // check if APC or uploadprogress are available
    // check for APC first ...
    $uploadOk = false;
    echo "<br />Checking if APC installed ... ";
    if (function_exists('apc_fetch')) {
      $uploadOk = true;
      echo "YES";
    } else {
      echo "NO";
    }

    // if that fails, check for uploadprogress
    if (! $uploadOk) {
      echo "<br />Checking if PECL package 'uploadprogress' installed ... ";
      if (function_exists('uploadprogress_get_info')) {
        $uploadOk = true;
        echo "YES";
      } else {
        echo "NO";
      }
    }
	
    if (! $uploadOk) {
      echo "<br />Warning: Progress bar for file upload will not work: Please install either 'APC 3.x' or 'uploadprogress 1.x' for PHP!";
    }
  }    

  function down ()
  {
    /* not available */
  }
}
?>
