SET FOREIGN_KEY_CHECKS=0;
SET NAMES "UTF8";

DELETE FROM studiport_file_types;
INSERT INTO studiport_file_types (type_id, name, picture, picture_large, picture_print, descr, mimefrag) VALUES
(1, 'Verschiedene Dateien', 'filetype-div.png', 'filetype-div-large.png', 'filetype-div-print.png', 'Diverse Dateien ohne Kategorie', ''),
(2, 'Dokumente', 'filetype-document.png', 'filetype-document-large.png', 'filetype-document-print.png', 'Dokumente wie PDF, Office, etc.', 'text'),
(3, 'Bilder', 'filetype-image.png', 'filetype-image-large.png', 'filetype-image-print.png', 'Bilddateien und Grafiken', 'image'),
(4, 'Video', 'filetype-video.png', 'filetype-video-large.png', 'filetype-video-print.png', 'Videos und Animationen', 'video'),
(5, 'Audio', 'filetype-audio.png', 'filetype-audio-large.png', 'filetype-audio-print.png', 'Audio- und Sprachdateien', 'audio'),
(6, 'Web-Ressourcen', 'filetype-web.png', 'filetype-web-large.png', 'filetype-web-print.png', 'Links zu Webseiten, RSS-Feeds, etc.', '');


DELETE FROM studiport_file_mime;
INSERT INTO studiport_file_mime (type_id, mime_type, descr) VALUES
(1, 'application/gzip', 'GNU Zip-Dateien'),
(2, 'application/ms-excel', 'Microsoft Excel Dateien'),
(2, 'application/msexcel', 'Microsoft Excel Dateien'),
(2, 'application/mspowerpoint', 'Microsoft Powerpoint Dateien'),
(2, 'application/msword', 'Microsoft Word Dateien'),
(1, 'application/octet-stream', 'Ausführbare Dateien'),
(2, 'application/pdf', 'Adobe PDF-Dateien'),
(3, 'application/postscript', 'Adobe PostScript-Dateien'),
(2, 'application/rtf Microsoft', 'RTF-Dateien'),
(2, 'application/vnc.oasis.opendocument.image-template', 'OpenOffice Document'),
(2, 'application/vnd.ms-excel', 'Microsoft Excel Dateien'),
(2, 'application/vnd.ms-powerpoint', 'Microsoft Powerpoint Dateien'),
(2, 'application/vnd.oasis.opendocument.chart', 'OpenOffice Document'),
(2, 'application/vnd.oasis.opendocument.chart-template', 'OpenOffice Document'),
(2, 'application/vnd.oasis.opendocument.formula', 'OpenOffice Document'),
(2, 'application/vnd.oasis.opendocument.formula-template', 'OpenOffice Document'),
(2, 'application/vnd.oasis.opendocument.graphics', 'OpenOffice Document'),
(2, 'application/vnd.oasis.opendocument.graphics-template', 'OpenOffice Document'),
(2, 'application/vnd.oasis.opendocument.image', 'OpenOffice Document'),
(2, 'application/vnd.oasis.opendocument.presentatio', ' OpenOffice Document'),
(2, 'application/vnd.oasis.opendocument.presentation-template', 'OpenOffice Document'),
(2, 'application/vnd.oasis.opendocument.spreadsheet', 'OpenOffice Document'),
(2, 'application/vnd.oasis.opendocument.spreadsheet-template', 'OpenOffice Document'),
(2, 'application/vnd.oasis.opendocument.text', 'OpenOffice Document'),
(2, 'application/vnd.oasis.opendocument.text-master', 'OpenOffice Document'),
(2, 'application/vnd.oasis.opendocument.text-template', 'OpenOffice Document'),
(2, 'application/vnd.oasis.opendocument.text-web', 'OpenOffice Document'),
(2, 'application/x-excel', 'Microsoft Excel Dateien'),
(1, 'application/x-gzip', 'Komprimierte Datei'),
(2, 'application/x-latex', 'LaTeX-Quelldateien'),
(2, 'application/x-msexcel', 'Microsoft Excel Dateien'),
(2, 'application/x-pdf', 'Adobe PDF-Dateien'),
(4, 'application/x-shockwave-flash', 'Flash Shockwave-Dateien'),
(1, 'application/x-tar', 'Zusammenfassende Datei'),
(2, 'application/x-tex', 'TeX-Dateien'),
(2, 'application/xhtml+xml', 'XHTML-Dateien'),
(2, 'application/xml', 'XML-Dateien'),
(1, 'application/zip', 'ZIP-Archivdateien'),
(1, 'text/plain', 'TXT-Datei');


DELETE FROM studiport_matrix_comp;
INSERT INTO studiport_matrix_comp (comp_id, title, descr, pos) VALUES
(1, 'Spezielles Fachwissen', 'Dieser Bereich umfasst sämtliche studienfachspezifischen Kenntnisse.', 1),
(2, 'Allgemeine, fachübergreifende Kenntnisse', 'Dieser Bereich umfasst u.a. die folgenden Kenntnisse und Fähigkeiten:<ul><li>Breites Grundlagenwissen</li><li>Fachübergreifendes Denken</li><li>Kenntnisse in EDV</li></ul>', 2),
(3, 'Lern-/Arbeitsmethoden und Umgang mit Informationen', 'Dieser Bereich umfasst u.a. die folgenden Kenntnisse und Fähigkeiten:<ul><li>Methodenauswahl und -anwendung (z.B. Analyse, Modellierung)</li><li>Wissenschaftliche Methoden</li><li>Analytische Fähigkeiten</li><li>Erkennen und Schließen von Wissenslücken</li><li>Identifikation und Beschaffung benötigter Informationen</li><li>Anwendung von vorhandenem Wissen auf neue Probleme</li></ul>', 3),
(4, 'Kooperation und Kommunikation', 'Dieser Bereich umfasst u.a. die folgenden Kenntnisse und Fähigkeiten:<ul><li>Kooperationsfähigkeit</li><li>Kommunikationsfähigkeit</li><li>Mündliche Ausdrucksfähigkeit</li><li>Schriftliche Ausdrucksfähigkeit</li><li>Fremdsprachen</li></ul>', 4),
(5, 'Unternehmerische Kompetenzen', 'Dieser Bereich umfasst u.a. die folgenden Kenntnisse und Fähigkeiten:<ul><li>Verhandlungsgeschick</li><li>Kundenberatung und -betreuung</li><li>Unternehmerisches Denken</li><li>Führungsqualitäten</li></ul>', 5),
(6, 'Weitere Schlüsselkompetenzen', 'Dieser Bereich umfasst u.a. die folgenden Kenntnisse und Fähigkeiten:<ul><li>Einstellung auf veränderte Umstände</li><li>Organisationsfähigkeit</li><li>Zielstrebigkeit</li><li>Einsatzbereitschaft</li><li>Übernahme von Verantwortung</li><li>Problemlösungsfähigkeit</li><li>Selbstständiges Arbeiten</li></ul>', 6),
(7, 'Produktplanung und -realisierung', 'Dieser Bereich umfasst u.a. die folgenden Kenntnisse und Fähigkeiten:<ul><li>Planung von Produkten (z.B. Maschinen, Apparate, EDV-Programme)</li><li>Realisierung von Produkten (z.B. Maschinen, Apparate, EDV-Programme)</li><li>Technologiefolgenabschätzung</li></ul>', 7);


DELETE FROM studiport_matrix_exp;
INSERT INTO studiport_matrix_exp (exp_id, title, descr, pos) VALUES
(1, 'Schule & Studium', 'Dieser Bereich umfasst Kenntnisse und Fähigkeiten, die in der Schule oder im Studium erworben bzw. entwickelt wurden.', 1),
(2, 'Beruf & Praktikum', 'Dieser Bereich umfasst Kenntnisse und Fähigkeiten, die in der Berufsausübung oder in Praktika erworben bzw. entwickelt wurden.', 1),
(3, 'Freizeit & Ehrenamt', 'Dieser Bereich umfasst Kenntnisse und Fähigkeiten, die in der Freizeit, also z.B. im Rahmen von Hobbys, ehrenamtlichen Tätigkeiten oder Weiterbildungsmaßnahmen, erworben bzw. entwickelt wurden.', 1);
