--
-- Tabellenstruktur für Tabelle `studiport_feedback_question`
--

CREATE TABLE IF NOT EXISTS `studiport_feedback_question` (
  `question_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `view_id` int(10) unsigned NOT NULL,
  `created` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `edited` timestamp NOT NULL,
  `expires` date NOT NULL DEFAULT '0000-00-00',
  `text` text NOT NULL,
  `public` enum('Y','N') NOT NULL DEFAULT 'N',
  PRIMARY KEY (`question_id`),
  KEY `studiport_feedback_question_ibfk_1` (`view_id`)
) ENGINE=MyISAM;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `studiport_feedback_request`
--

CREATE TABLE IF NOT EXISTS `studiport_feedback_request` (
  `question_id` int(10) unsigned NOT NULL,
  `user_id` char(32) NOT NULL,
  PRIMARY KEY (`question_id`,`user_id`)
) ENGINE=MyISAM;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `studiport_feedback_response`
--

CREATE TABLE IF NOT EXISTS `studiport_feedback_response` (
  `response_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `question_id` int(10) unsigned NOT NULL,
  `user_id` char(32) DEFAULT NULL,
  `author` varchar(255) DEFAULT NULL,
  `created` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `edited` timestamp NOT NULL,
  `text` text,
  `viewed` enum('Y','N') NOT NULL DEFAULT 'N',
  PRIMARY KEY (`response_id`),
  KEY `studiport_feedback_response_ibfk_1` (`question_id`)
) ENGINE=MyISAM ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `studiport_file`
--

CREATE TABLE IF NOT EXISTS `studiport_file` (
  `file_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `int_filename` varchar(255) DEFAULT NULL,
  `filename` varchar(255) NOT NULL,
  `type_id` int(10) unsigned NOT NULL,
  `mimetype` varchar(255) NOT NULL,
  `filesize` int(10) unsigned NOT NULL,
  `created` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `edited` timestamp NOT NULL,
  `title` varchar(255) NOT NULL,
  `descr_int` text,
  `descr_ext` text,
  `user_id` char(32) NOT NULL,
  PRIMARY KEY (`file_id`),
  KEY `user_id` (`user_id`),
  KEY `type_id` (`type_id`)
) ENGINE=MyISAM;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `studiport_file_assoc`
--

CREATE TABLE IF NOT EXISTS `studiport_file_assoc` (
  `file_id` int(10) unsigned NOT NULL,
  `comp_id` int(10) unsigned NOT NULL,
  `exp_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`file_id`),
  KEY `comp_id` (`comp_id`,`exp_id`),
  KEY `studiport_file_assoc_ibfk_3` (`exp_id`)
) ENGINE=MyISAM;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `studiport_file_mime`
--

CREATE TABLE IF NOT EXISTS `studiport_file_mime` (
  `type_id` int(10) unsigned NOT NULL,
  `mime_type` varchar(255) NOT NULL,
  `descr` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`mime_type`),
  KEY `studiport_file_mime_ibfk_1` (`type_id`)
) ENGINE=MyISAM;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `studiport_file_types`
--

CREATE TABLE IF NOT EXISTS `studiport_file_types` (
  `type_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL,
  `picture` varchar(255) NOT NULL DEFAULT 'filetype-unknown.png',
  `picture_large` varchar(255) NOT NULL DEFAULT 'filetype-unknown-large.png',
  `picture_print` varchar(255) NOT NULL DEFAULT 'filetype-unknown.pdf',
  `descr` varchar(255) DEFAULT NULL,
  `mimefrag` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`type_id`)
) ENGINE=MyISAM;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `studiport_matrix_cell_descr`
--

CREATE TABLE IF NOT EXISTS `studiport_matrix_cell_descr` (
  `user_id` char(32) NOT NULL,
  `comp_id` int(10) unsigned NOT NULL,
  `exp_id` int(10) unsigned NOT NULL,
  `text_ext` text,
  `text_int` text,
  `created` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `edited` timestamp NOT NULL,
  PRIMARY KEY (`user_id`,`comp_id`,`exp_id`),
  KEY `comp_id` (`comp_id`),
  KEY `exp_id` (`exp_id`)
) ENGINE=MyISAM;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `studiport_matrix_comp`
--

CREATE TABLE IF NOT EXISTS `studiport_matrix_comp` (
  `comp_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `descr` text,
  `pos` tinyint(4) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`comp_id`)
) ENGINE=MyISAM;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `studiport_matrix_comp_hide`
--

CREATE TABLE IF NOT EXISTS `studiport_matrix_comp_hide` (
  `comp_id` int(10) unsigned NOT NULL,
  `user_id` char(32) NOT NULL,
  PRIMARY KEY (`comp_id`,`user_id`)
) ENGINE=MyISAM;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `studiport_matrix_exp`
--

CREATE TABLE IF NOT EXISTS `studiport_matrix_exp` (
  `exp_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `descr` text,
  `pos` tinyint(4) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`exp_id`)
) ENGINE=MyISAM ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `studiport_matrix_exp_hide`
--

CREATE TABLE IF NOT EXISTS `studiport_matrix_exp_hide` (
  `exp_id` int(10) unsigned NOT NULL,
  `user_id` char(32) NOT NULL,
  PRIMARY KEY (`exp_id`,`user_id`)
) ENGINE=MyISAM;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `studiport_view`
--

CREATE TABLE IF NOT EXISTS `studiport_view` (
  `view_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL,
  `descr` text,
  `user_id` char(32) NOT NULL,
  `expires` date NOT NULL DEFAULT '0000-00-00',
  `created` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `edited` timestamp NOT NULL,
  `public` enum('Y','N') NOT NULL DEFAULT 'N',
  `access_code` char(32) NOT NULL,
  PRIMARY KEY (`view_id`)
) ENGINE=MyISAM;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `studiport_view_access`
--

CREATE TABLE IF NOT EXISTS `studiport_view_access` (
  `view_id` int(10) unsigned NOT NULL,
  `user_id` char(32) NOT NULL,
  `viewed` enum('Y','N') NOT NULL DEFAULT 'N',
  `accesstime` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`view_id`,`user_id`)
) ENGINE=MyISAM;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `studiport_view_files`
--

CREATE TABLE IF NOT EXISTS `studiport_view_files` (
  `view_id` int(10) unsigned NOT NULL,
  `file_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`view_id`,`file_id`),
  KEY `studiport_view_files_ibfk_2` (`file_id`)
) ENGINE=MyISAM;


